Index: /branches/RBFRegression/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessRegression.cs
===================================================================
--- /branches/RBFRegression/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessRegression.cs	(revision 14891)
+++ /branches/RBFRegression/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessRegression.cs	(revision 14892)
@@ -42,6 +42,5 @@
 
     public override Type ProblemType { get { return typeof(IRegressionProblem); } }
-    public new IRegressionProblem Problem
-    {
+    public new IRegressionProblem Problem {
       get { return (IRegressionProblem)base.Problem; }
       set { base.Problem = value; }
@@ -53,20 +52,16 @@
 
     #region parameter properties
-    public IConstrainedValueParameter<IGaussianProcessRegressionModelCreator> GaussianProcessModelCreatorParameter
-    {
+    public IConstrainedValueParameter<IGaussianProcessRegressionModelCreator> GaussianProcessModelCreatorParameter {
       get { return (IConstrainedValueParameter<IGaussianProcessRegressionModelCreator>)Parameters[ModelCreatorParameterName]; }
     }
-    public IFixedValueParameter<GaussianProcessRegressionSolutionCreator> GaussianProcessSolutionCreatorParameter
-    {
+    public IFixedValueParameter<GaussianProcessRegressionSolutionCreator> GaussianProcessSolutionCreatorParameter {
       get { return (IFixedValueParameter<GaussianProcessRegressionSolutionCreator>)Parameters[SolutionCreatorParameterName]; }
     }
-    public IFixedValueParameter<BoolValue> CreateSolutionParameter
-    {
+    public IFixedValueParameter<BoolValue> CreateSolutionParameter {
       get { return (IFixedValueParameter<BoolValue>)Parameters[CreateSolutionParameterName]; }
     }
     #endregion
     #region properties
-    public bool CreateSolution
-    {
+    public bool CreateSolution {
       get { return CreateSolutionParameter.Value.Value; }
       set { CreateSolutionParameter.Value.Value = value; }
Index: /branches/RBFRegression/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/CicularKernel.cs
===================================================================
--- /branches/RBFRegression/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/CicularKernel.cs	(revision 14891)
+++ /branches/RBFRegression/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/CicularKernel.cs	(revision 14892)
@@ -45,6 +45,6 @@
     protected override double Get(double norm) {
       var beta = Beta.Value;
-      if (Math.Abs(Beta.Value) < double.Epsilon) return double.NaN;
-      if (norm >= Beta.Value) return 0;
+      if (Math.Abs(beta) < double.Epsilon) return double.NaN;
+      if (norm >= beta) return 0;
       var d = norm / beta;
       return 2 * Math.PI * (Math.Acos(-d) - d * Math.Sqrt(1 - d * d));
Index: /branches/RBFRegression/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/PolysplineKernel.cs
===================================================================
--- /branches/RBFRegression/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/PolysplineKernel.cs	(revision 14891)
+++ /branches/RBFRegression/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/PolysplineKernel.cs	(revision 14892)
@@ -37,12 +37,10 @@
     #endregion
     #region Parameterproperties
-    public IFixedValueParameter<DoubleValue> DegreeParameter
-    {
+    public IFixedValueParameter<DoubleValue> DegreeParameter {
       get { return Parameters[DegreeParameterName] as IFixedValueParameter<DoubleValue>; }
     }
     #endregion
     #region Properties
-    public DoubleValue Degree
-    {
+    public DoubleValue Degree {
       get { return DegreeParameter.Value; }
     }
Index: /branches/RBFRegression/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/ThinPlatePolysplineKernel.cs
===================================================================
--- /branches/RBFRegression/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/ThinPlatePolysplineKernel.cs	(revision 14891)
+++ /branches/RBFRegression/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/ThinPlatePolysplineKernel.cs	(revision 14892)
@@ -37,12 +37,10 @@
     #endregion
     #region Parameterproperties
-    public IFixedValueParameter<DoubleValue> DegreeParameter
-    {
+    public IFixedValueParameter<DoubleValue> DegreeParameter {
       get { return Parameters[DegreeParameterName] as IFixedValueParameter<DoubleValue>; }
     }
     #endregion
     #region Properties
-    public DoubleValue Degree
-    {
+    public DoubleValue Degree {
       get { return DegreeParameter.Value; }
     }
Index: /branches/RBFRegression/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelRidgeRegressionModel.cs
===================================================================
--- /branches/RBFRegression/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelRidgeRegressionModel.cs	(revision 14891)
+++ /branches/RBFRegression/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelRidgeRegressionModel.cs	(revision 14892)
@@ -32,6 +32,5 @@
   [Item("KernelRidgeRegressionModel", "A kernel ridge regression model")]
   public sealed class KernelRidgeRegressionModel : RegressionModel {
-    public override IEnumerable<string> VariablesUsedForPrediction
-    {
+    public override IEnumerable<string> VariablesUsedForPrediction {
       get { return allowedInputVariables; }
     }
@@ -39,6 +38,5 @@
     [Storable]
     private readonly string[] allowedInputVariables;
-    public string[] AllowedInputVariables
-    {
+    public string[] AllowedInputVariables {
       get { return allowedInputVariables; }
     }
@@ -148,6 +146,5 @@
         }
         LooCvRMSE = Math.Sqrt(ssqLooError / n);
-      }
-      catch (alglib.alglibexception ae) {
+      } catch (alglib.alglibexception ae) {
         // wrap exception so that calling code doesn't have to know about alglib implementation
         throw new ArgumentException("There was a problem in the calculation of the kernel ridge regression model", ae);