Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/DataPreprocessingView.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/DataPreprocessingView.cs	(revision 14902)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/DataPreprocessingView.cs	(revision 14903)
@@ -126,11 +126,22 @@
     }
     private void newRegressionToolStripMenuItem_Click(object sender, EventArgs e) {
-      Content.Import(new RegressionProblemData());
+      if (CheckNew("Regression"))
+        Content.Import(new RegressionProblemData());
     }
     private void newClassificationToolStripMenuItem_Click(object sender, EventArgs e) {
-      Content.Import(new ClassificationProblemData());
+      if (CheckNew("Classification"))
+        Content.Import(new ClassificationProblemData());
     }
     private void newTimeSeriesToolStripMenuItem_Click(object sender, EventArgs e) {
-      Content.Import(new TimeSeriesPrognosisProblemData());
+      if (CheckNew("Time Series Prognosis"))
+        Content.Import(new TimeSeriesPrognosisProblemData());
+    }
+
+    private bool CheckNew(string type) {
+      return DialogResult.OK == MessageBox.Show(
+               this,
+               string.Format("When creating a new {0}, all previous information will be lost.", type),
+               "Continue?",
+               MessageBoxButtons.OKCancel, MessageBoxIcon.Warning);
     }
     #endregion
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/Utils/VerticalLabel.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/Utils/VerticalLabel.cs	(revision 14902)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/Utils/VerticalLabel.cs	(revision 14903)
@@ -1,4 +1,3 @@
-﻿
-#region License Information
+﻿#region License Information
 /* HeuristicLab
  * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/DataCompletenessChartContent.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/DataCompletenessChartContent.cs	(revision 14902)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/DataCompletenessChartContent.cs	(revision 14903)
@@ -1,8 +1,29 @@
-﻿using System.Drawing;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 
 namespace HeuristicLab.DataPreprocessing {
-  [Item("DataCompletenessChart", "Represents a datacompleteness chart.")]
+  [Item("Data Completeness Chart", "Represents a datacompleteness chart.")]
 
   public class DataCompletenessChartContent : Item, IViewShortcut {
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/DataGridContent.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/DataGridContent.cs	(revision 14902)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/DataGridContent.cs	(revision 14903)
@@ -30,5 +30,5 @@
 namespace HeuristicLab.DataPreprocessing {
 
-  [Item("DataGrid", "Represents a data grid.")]
+  [Item("Data Grid", "Represents a data grid.")]
   public class DataGridContent : Item, IStringConvertibleMatrix, IViewShortcut {
 
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/LineChartContent.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/LineChartContent.cs	(revision 14902)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/LineChartContent.cs	(revision 14903)
@@ -26,5 +26,5 @@
 namespace HeuristicLab.DataPreprocessing {
 
-  [Item("LineChart", "Represents the line chart grid.")]
+  [Item("Line Chart", "Represents the line chart grid.")]
   public class LineChartContent : PreprocessingChartContent {
 
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/MultiScatterPlotContent.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/MultiScatterPlotContent.cs	(revision 14902)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/MultiScatterPlotContent.cs	(revision 14903)
@@ -26,5 +26,5 @@
 namespace HeuristicLab.DataPreprocessing {
 
-  [Item("MultiScatterPlot", "Represents a multi scatter plot.")]
+  [Item("Multi Scatter Plot", "Represents a multi scatter plot.")]
   public class MultiScatterPlotContent : ScatterPlotContent {
 
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/SingleScatterPlotContent.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/SingleScatterPlotContent.cs	(revision 14902)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/SingleScatterPlotContent.cs	(revision 14903)
@@ -26,5 +26,5 @@
 namespace HeuristicLab.DataPreprocessing {
 
-  [Item("ScatterPlot", "Represents a scatter plot.")]
+  [Item("Scatter Plot", "Represents a scatter plot.")]
   public class SingleScatterPlotContent : ScatterPlotContent {
 